//mapCode.js

var markers;
var innovators = [];
var numInnovators;
var coords = [];
var infoWindow;
var taglines = [];
var boxList = [];

var mapOptions = {
  center: new google.maps.LatLng( 37.346, -95.4037),
  zoom: 3,
  minZoom:3,
  maxZoom:12,
  mapTypeId: google.maps.MapTypeId.ROADMAP,
  streetViewControl:false,
  mapTypeControl:false,
  styles:[
	  {
		"featureType": "transit",
		"stylers": [
		  { "visibility": "off" }
		]
	  },{
		"featureType": "road",
		"stylers": [
		  { "visibility": "off" }
		]
	  },{
		"featureType": "poi",
		"stylers": [
		  { "visibility": "off" }
		]
	  },{
		"featureType": "landscape",
		"stylers": [
		  { "visibility": "off" }
		]
	  },{
	  },{
		"featureType": "administrative.province",
		"elementType": "geometry.stroke",
		"stylers": [
		  { "weight": 2 }
		]
	  },{
		"featureType": "administrative.country",
		"elementType": "geometry.stroke",
		"stylers": [
		  { "weight": 3 }
		]
	  },{
		"featureType": "water",
		"elementType": "geometry.fill",
		"stylers": [
		  { "color": "#6997be" }
		]
	  },{
	  },{
		"featureType": "administrative.land_parcel",
		"stylers": [
		  { "visibility": "off" }
		]
	  },{
		"featureType": "administrative",
		"elementType": "geometry.fill",
		"stylers": [
		  { "visibility": "off" }
		]
	  },{
	  }
	]
}

var map;
	
var allowedBounds = new google.maps.LatLngBounds(
     new google.maps.LatLng(15, -125), 
     new google.maps.LatLng(50, -70)
);

google.maps.event.addDomListener(window, 'load', initMap);

function initMap(){
	setTimeout(function(){
		
		buildMap();
		getInnovators();
		addOverlays();

	},500);
	
	
}

function buildMap(){
		map = new google.maps.Map(document.getElementById("mapView"),
		mapOptions);
		
		google.maps.event.addListener(map, 'click', closeWindows);
		
		var lastValidCenter = map.getCenter();

		google.maps.event.addListener(map, 'center_changed', function() {
			if (allowedBounds.contains(map.getCenter())) {
				// still within valid bounds, so save the last valid position
				lastValidCenter = map.getCenter();
				return; 
			}

			// not valid anymore => return to last valid position
			map.panTo(lastValidCenter);
		});
	
}

function getInnovators(){

		while (innovators.length > 0 )
		innovators.pop();

	$.getJSON(API+"Taglines", function(tags) {
		
		for (var i =0; i < tags.length;i++){
			taglines[tags[i].TaglineID-1] = tags[i].Name;
		}
		
		populateAddStory(taglines);
	
		$.getJSON(API+"mapstories.aspx", function(json) {
		   numInnovators = json.length;
		   for (var i = 0; i < json.length;i++){
				
				
				
				
				function op(ind){

					 
					 $.getJSON(API+"Stories/"+json[ind].StoryID, function(stor) {
						var inno = new Innovator(stor[0],taglines);
						var cor = new google.maps.LatLng(stor[0].Lat,stor[0].Lon);
						inno.coord = cor;
						coords.push(cor);
						innovators.push(inno)
						if (innovators.length == numInnovators)
							addMarkers();
					 });
				}
				
				op(i);
				
		   }
		 });
	 });
	
}

function addMarkers(){

	console.log(innovators.length);
	for (var i = 0; i < innovators.length;i++){
		buildMarker(i); 
	}
	
	function buildMarker(ind){
		var marker = new google.maps.Marker({
		  position: innovators[ind].coord,
		  map: map,
		  icon:"pin.png",
		  shadow:"shadow.png",
		  title:innovators[ind].name
		});
		  marker.person = innovators[ind];
		  
		  console.log("marker built")
		
		var inBox = $('<div>').css({background:"#d1d1d1",display:"inline-block","margin-top":"8px",float:"left",position:"absolute",border:"2px solid black",padding:"2px"});
		var inPic = $('<img>').attr("src",PICTURE_PATH+marker.person.picture+"_155140.png").css({display:"block",width:100,height:140*(100/155),margin:2});
		var inName = $('<p>').css({"margin-top":0,"margin-bottom":0,"font-family":"Ubuntu","font-size":"16px","line-height":"17px", "text-align":"center"});
		var inTag = $('<p>').css({"margin-top":0,"font-family":"Ubuntu","font-size":"12px","line-height":"12px", "text-align":"center"});
		
		inName.get(0).innerHTML = marker.person.name;
		inTag.get(0).innerHTML = marker.person.tagline;
		
		inBox.append(inPic)
		inBox.append(inName)
		inBox.append(inTag)
		
		console.log("box built");
		
		
		var myOptions = {
                 content: inBox.get(0)
                ,maxWidth: 0
				,alignBottom:false
                ,pixelOffset: new google.maps.Size(-55, 0)
                ,zIndex: null
				,boxStyle: { 
                  background: "url('tipbox.gif') no-repeat"
                  ,width: "104px"
                 }
                ,closeBoxURL: "http://www.google.com/intl/en_us/mapfiles/close.gif"
				,closeBoxMargin: "10px 2px 2px 2px"
                ,infoBoxClearance: new google.maps.Size(1, 1)
                ,isHidden: false
				,pane: "floatPane" 
                ,enableEventPropagation: true
        };
		
		
		  
		  
		  var thisWindow = new InfoBox(myOptions);
		  
		  thisWindow.index = boxList.length;
			boxList.push(thisWindow);
		  
			/*google.maps.event.addListener(marker, 'mouseover', function() {
				
				thisWindow.open(map,marker);	
				
			});
			
			google.maps.event.addListener(marker, 'mouseout', function() {
				
					thisWindow.close();
					
				});
				
			google.maps.event.addListener(marker, 'click', function() {
				
					populateProfile(marker.person);
					
				});*/
		  
		  
		  google.maps.event.addListener(marker, 'click', function() {
				
				thisWindow.open(map,marker);
				closeWindows(thisWindow.index);
				
			});
			
			 google.maps.event.addDomListener(inBox.get(0),'click',function(e){
				e.preventDefault();
				e.stopImmediatePropagation()
			populateProfile(marker.person); });
			
			console.log("listeners in place");
	}
}

function closeWindows(ind){
	
		for (var i = 0; i < boxList.length;i++){
			if (i != ind){
				boxList[i].close();
			}
		}
	
}

function addOverlays(){

	var states = [];
	
	$.getJSON(API+"mapStates.aspx", function(json) {
		states = json;
		
		readXML();
		
	});
	
	function readXML(){
	
		jQuery.get("http://innovation.ce.org/states.xml", {}, function(data) {
			jQuery(data).find("state").each(function() {
			  var name = this.getAttribute('name');
			  if ($.inArray(name, states) > -1){
				  var points = this.getElementsByTagName("point");
				  
				  var pts = [];
				  for (var i = 0; i < points.length; i++) {
					pts[i] = new google.maps.LatLng(parseFloat(points[i].getAttribute("lat")), parseFloat(points[i].getAttribute("lng")));
				  }
				  var poly = new google.maps.Polygon({
					paths: pts,
					strokeColor: '#000000',
					strokeOpacity: 1,
					fillColor: '#FFFFFF',
					fillOpacity: 0.40,
					strokeWeight:0,
				  });
				  //polys.push(poly);
				  poly.setMap(map);
				  
				  google.maps.event.addListener(poly, 'click', closeWindows);
				  
			  }
			});
		  });
	}

	
	
}



